import { ComponentID } from '@teambit/component';
import { EnvContext } from '@teambit/envs';
import { IsolatorMain } from '@teambit/isolator';
import { Workspace } from '@teambit/workspace';
/**
 * Returns the workspace instance from the context, if it's available, or undefined otherwise.
 */
export declare function getWorkspace(context: EnvContext): Workspace | undefined;
export declare function getNodeModulesPaths(build: boolean, isolator: IsolatorMain, workspace?: Workspace): string[];
/**
 * Returns the value of the option or its default value if undefined
 */
export declare function optionValue<T>(value: T | undefined, defaultValue: T): T;
export declare function loadEsmModule<T>(modulePath: string): Promise<T>;
export declare function cmpIdToPkgName(componentId: ComponentID): string;
