"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.cmpIdToPkgName = exports.loadEsmModule = exports.optionValue = exports.getNodeModulesPaths = exports.getWorkspace = void 0;
const workspace_1 = require("@teambit/workspace");
const path_1 = require("path");
/**
 * Returns the workspace instance from the context, if it's available, or undefined otherwise.
 */
function getWorkspace(context) {
    // TODO: replace this try catch with context.hasAspect once it's available from harmony
    try {
        return context.getAspect(workspace_1.WorkspaceAspect.id);
    }
    catch (err) {
        // Ignore this. We might be running not from within a workspace, for example, when using bit sign.
    }
    return undefined;
}
exports.getWorkspace = getWorkspace;
function getNodeModulesPaths(build, isolator, workspace) {
    const nodeModulesPaths = [];
    if (workspace) {
        const workspaceDir = workspace.path;
        const scopeAspectsRootDir = isolator.getCapsulesRootDir({ baseDir: workspace.scope.getAspectCapsulePath() });
        const workspaceCapsulesRootDir = build ? isolator.getCapsulesRootDir({ baseDir: workspace.path }) : undefined;
        const workspaceNodeModules = (0, path_1.resolve)(workspaceDir, 'node_modules');
        if (workspaceCapsulesRootDir) {
            const workspaceCapsuleNodeModules = (0, path_1.resolve)(workspaceCapsulesRootDir, 'node_modules');
            // Add the workspace capsule node modules
            nodeModulesPaths.push(workspaceCapsuleNodeModules);
        }
        // Check if we are in the aspects' capsule
        if (!__dirname.startsWith(workspaceNodeModules)) {
            const aspectsCapsuleNodeModules = (0, path_1.resolve)(scopeAspectsRootDir, 'node_modules');
            // Add the aspects capsule node modules
            nodeModulesPaths.push(aspectsCapsuleNodeModules);
        }
        // Add the workspace node modules
        nodeModulesPaths.push(workspaceNodeModules, 'node_modules');
    }
    if (!nodeModulesPaths.includes('node_modules')) {
        nodeModulesPaths.push('node_modules');
    }
    return nodeModulesPaths;
}
exports.getNodeModulesPaths = getNodeModulesPaths;
/**
 * Returns the value of the option or its default value if undefined
 */
function optionValue(value, defaultValue) {
    return typeof value === 'undefined' ? defaultValue : value;
}
exports.optionValue = optionValue;
function loadEsmModule(modulePath) {
    return __awaiter(this, void 0, void 0, function* () {
        try {
            return yield Promise.resolve().then(() => __importStar(require(modulePath)));
        }
        catch (e) {
            return new Function('modulePath', `return import(modulePath)`)(modulePath);
        }
    });
}
exports.loadEsmModule = loadEsmModule;
function cmpIdToPkgName(componentId) {
    const allSlashes = new RegExp('/', 'g');
    const name = componentId.fullName.replace(allSlashes, '.');
    const scope = componentId.scope.split('.').join('/');
    const partsToJoin = scope ? [scope, name] : [name];
    return `@${partsToJoin.join('.')}`;
}
exports.cmpIdToPkgName = cmpIdToPkgName;
//# sourceMappingURL=utils.js.map